/*
 *
 * Beryl proc lists 
 *
 * lists.c
 *
 * Copyright (c) 2006 Robert Carr <racarr@beryl-project.org>
 *
 * This program is free software {} you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation {} either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY {} without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */
#include <beryl.h>
#include <beryl_ipcs.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <beryl-private.h>
#include <glib.h>

void addDisplayProc(CompDisplay *d, char * plugin, int func, proc_ptr funcPtr)
{
	procListNode * walk;
	
	walk=d->procs[func]->head;

	while (walk)
	{
		if (!strcasecmp(plugin,walk->plugin))
		{
			walk->proc=funcPtr;
			return;
		}
		walk++;
	}
}

void addScreenProc(CompScreen *s, char * plugin, int func, proc_ptr funcPtr)
{
	procListNode * walk;
	walk = s->procs[func]->head;
	
	while (walk)
	{
		if (!strcasecmp(plugin,walk->plugin))
		{
			walk->proc=funcPtr;
			return;
		}
		walk++;
	}

}


void removeDisplayProcByPlugin(CompDisplay *d, int func, char * plugin)
{
	procListNode * walk;
	walk=d->procs[func]->head;

	while (walk)
	{
		if (!strcasecmp(plugin,walk->plugin))
		{
			walk->proc=0;
			return;
		}
		walk++;
	}
}

void removeScreenProcByPlugin(CompScreen *s, int func, char * plugin) 
{
	procListNode * walk;
	walk=s->procs[func]->head;
	while (walk)
	{
		if (!strcasecmp(plugin,walk->plugin))
		{
			walk->proc=0;
			return;
		}
		walk++;
	}
}

void removeDisplayProc(CompDisplay *d, int func, proc_ptr funcPtr) 
{
	procListNode * walk;
	walk = d->procs[func]->head;
	while (walk)
	{
		if (funcPtr == walk->proc)
		{
			walk->proc=0;
			return;
		}
		walk++;
	}
}

void removeScreenProc(CompScreen *s, int func, proc_ptr funcPtr)
{
	procListNode * walk;
	walk = s->procs[func]->head;
	while (walk)
	{
		if (funcPtr == walk->proc)
		{
			walk->proc=0;
			return;
		}
		walk++;
	}
}

void removeDisplayProcsForPlugin(CompDisplay *d, char * plugin)
{
	procListNode *walk;
	int pluginLoc=0;
	int i;
	walk=d->procs[0]->head;	

	while (walk)
	{
		if (!strcasecmp(plugin,walk->plugin))
		{
			walk->proc=0;
			break;
		}
		pluginLoc++;
		walk++;
	}

	for (i = 1; i < DisplayProcsNum;i++)
	{
		walk=d->procs[i]->head;
		walk+=pluginLoc;
		walk->proc=0;
	}
}
void removeScreenProcsForPlugin(CompScreen *s, char * plugin)
{
	procListNode * walk;
	int pluginLoc=0;
	int i;
	walk=s->procs[0]->head;
	

	while (walk)
	{
		if (!strcasecmp(plugin,walk->plugin))
		{
			walk->proc=0;
			break;
		}
		pluginLoc++;
		walk++;
	}

	for (i = 1; i < ScreenProcsNum;i++)
	{
		walk=s->procs[i]->head;
		walk+=pluginLoc;
		walk->proc=0;
	}

}
 

Bool setDisplayProcNext(CompDisplay *d, int func) 
{
	procListHeader *header;
	
	header = d->procs[func];

	header->current = header->current->prev ? header->current->prev : header->coreFunc;
	
	*(header->handle)=header->current->proc; /* Problem?? Also in screenInit */
	
}



Bool setScreenProcNext(CompScreen *s, int func) 
{
	
	procListHeader *header;
	header = s->procs[func];
	header->current=header->current->prev ? header->current->prev : header->coreFunc;
	*(header->handle)=header->current->prev;
}

void resetDisplayProc(CompDisplay *d, int func) 
{
	procListHeader *header;
	header = d->procs[func];
	
	header->current=header->tail;
	
	*(header->handle)=header->current->proc; /* Problem?? Also in screenInit */
	
}
void resetScreenProc(CompScreen *s, int func) 
{
	
	procListHeader *header;
	header=s->procs[func];
	header->current=header->tail;
	
	*(header->handle)=header->current->proc;
}
